/** 
 * This program is free software: you can redistribute it and/or modify it under the terms of the
 * GNU Affero General Public License as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
 * even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Affero General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License along with this program.
 * If not, see http://www.gnu.org/licenses/.
*/
package com.owc.singularity.engine.ports.extender;

/**
 * Superclass of behaviour classes that generate ports as needed.
 * 
 * @author Simon Fischer
 * 
 */
public interface PortExtender {

    /**
     * Prefix for the names of the input ports generated by this port extender. Can return null, if
     * no input ports defined.
     */
    public String getInputGroupNamePrefix();

    /**
     * Prefix for the names of the output ports generated by this port extender. Can return null if
     * no output ports defined.
     */
    public String getOutputGroupNamePrefix();

    /** Asks the port extender to generate at least this number of ports. */
    public void ensureMinimumNumberOfPorts(int minNumber);

}
